<template>
  <div class="history">
    <div class="bottom-pusher">
      <template v-if="showLast">
        <div class="last-message">
          <div class="header">
            <span class="ok-icon"> 
              <img src="~@/assets/icons/ok.svg">
            </span>
            <img class="close" src="~@/assets/icons/small-close.svg" @click="closeEnd">
          </div>
          <p class="title">
            Все ходы записаны! 
          </p>
          <p class="text">
            Расшифровка разговора автоматически загрузится на ваше устройство. Вы можете сохранить задачи в свою CRM-систему.
          </p>
          <div class="buttons">
            <v-button class="green" @click="saveText">
              Скачать файл 
            </v-button>
            <br/>
            <v-button class="green line text-green" @click="saveTasks">
              Сохранить задачи
            </v-button>
          </div>
        </div>
      </template>
      <template v-else>
        <div class="buble-list" v-if="showHistory" @wheel="scrollList" ref="scrolList">
          <buble v-for="(mess, index) in reverseMess" :message="mess" :key="`message-${mess.uuid}`"/>
          <div class="bacground-placer"></div>
        </div>


        <div class="buttons-list">
          <template v-if="isStarted">
            <v-button class="white show-button" :class="{
              active: showHistory
            }" @click="toggleHistory">
              <img src="~@/assets/icons/chat.svg" >
              <img src="~@/assets/icons/shevron.svg" class="schevron">
            </v-button>
            <v-button class="red round" @click="stopRecord">
              <img src="~@/assets/icons/stop.svg" >
            </v-button>
          </template>
          <template v-else>

            <v-button class="green" @click="startRecord">
              Начать
            </v-button>

            <v-button class="white round" @click="closeApp">
              <img src="~@/assets/icons/close.svg" >
            </v-button>

          </template>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
  import Buble from './Buble.vue'
  import VButton from './VButton.vue'
  import { remote } from 'electron'
  import { mapState } from 'vuex'

  const formatDate = (date) => {
    return `${date.getDate()}.${date.getMonth() + 1}.${date.getFullYear()} ${strPad(date.getHours())}:${strPad(date.getMinutes())}`
  }

  const strPad = (number) => {
    return String(number).padStart(2, '0')
  }

  const saveToFile = (output, filename) => {
    let file = new Blob([output], { type: 'text/plain;charset=utf-8' })
    if (window.navigator.msSaveOrOpenBlob) {
      window.navigator.msSaveOrOpenBlob(file, filename)
    } else { // Others
      let a = document.createElement('a')
      let url = URL.createObjectURL(file)
      a.href = url
      a.download = filename
      document.body.appendChild(a)
      a.click()
      setTimeout(function () {
        document.body.removeChild(a)
        window.URL.revokeObjectURL(url)
      }, 0)
    }
  }

  export default {
    name: 'MainPage',
    components: { Buble, VButton },
    data () {
      return {
        showTextList: false,
        isStarted: false,
        showLast: false
      }
    },
    computed: {
      ...mapState(['messages']),
      showHistory () {
        return this.showTextList && this.isStarted
      },
      reverseMess () {
        return this.messages.slice().reverse()
      }
    },
    methods: {
      toggleHistory () {
        this.showTextList = !this.showTextList
        if (this.showTextList) {
          this.$nextTick(() => {
            this.$refs.scrolList.scrollTop = this.$refs.scrolList.scrollHeight
          })
        }
      },
      startRecord () {
        this.$socket.send('start')
        this.isStarted = true
      },
      stopRecord () {
        this.$socket.send('stop')
        this.isStarted = false
        this.showLast = true
      },

      scrollList (event) {
        this.$refs.scrolList.scrollTop += event.deltaY
      },
      closeApp () {
        remote.getCurrentWindow().close()
      },
      closeEnd () {
        this.$store.commit('clear')
        this.showLast = false
      },
      saveTasks () {
        let filename = 'tasks.txt'
        let output = ''

        for (let message of this.messages.filter(item => item.tasks.length > 0)) {
          output += `
${formatDate(message.date)}
-------------------------------
${message.text}

          `
        }
        saveToFile(output, filename)
      },
      saveText () {
        let filename = 'dialog.txt'
        let output = ''

        const getUser = (id) => {
          let user = this.$store.getters.getUserById(id)
          if (user) {
            return user.name
          }
          return `Неизвестный ${id}`
        }

        for (let message of this.messages.filter(item => item.tasks.length === 0)) {
          output += `
${getUser(message.user)}, ${formatDate(message.date)}, ${message.speachColor}
-------------------------------
${message.text}

          `
        }
        saveToFile(output, filename)
      }
    }
  }
</script>

<style lang="scss">
.history{
  padding: 0px 0px 30px;
  height: 100%;
  display: grid;
  box-sizing: border-box;

  .bottom-pusher{
    align-self: end;
  }
  
  .last-message{
    background: #FFFFFF;
    pointer-events: auto;
    /* Тень под окном */
    box-shadow: 0px 10px 45px rgba(16, 0, 79, 0.45);
    border-radius: 15px;

    margin: 0px 30px;
    padding: 30px;
    margin-bottom: 40%;

    .header{
      display: flex;
      justify-content: space-between;
      align-items: start;
      .close{
        cursor: pointer;
      }
      .ok-icon{
        background: #1AD16E;
        border-radius: 100%;
        width: 64px;
        text-align: center;
        padding: 19px 0px;
        img{
          width: 34px;
          height: auto;
        }
      }
    }

    .title{
      font-style: normal;
      font-weight: 500;
      font-size: 36px;
      line-height: 150%;
    }
    .text{
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 150%;
      margin-bottom: 30px;
    }
    .buttons{
      .btn{
        width: 60%;
        text-align: center;
        margin-bottom: 15px;
      }
    }
  }

  .buble-list{
    padding: 0px 30px 30px;
    overflow: hidden;
    height: calc(100vh - 116px);
    mask-image: linear-gradient(rgba(0,0,0,0) 0%, rgba(0,0,0,1) 30% , rgba(0,0,0,1) 90%, rgba(0,0,0,0) 100%);
    -webkit-mask-image: linear-gradient(rgba(0,0,0,0) 0%, rgba(0,0,0,1) 30% , rgba(0,0,0,1) 96%, rgba(0,0,0,0) 100%);
    display: flex;
    flex-direction: column-reverse;
    position: relative;

    .bacground-placer{
      position: absolute;
      width: calc(100% - 60px);
      height: calc(100% - 30px);
      z-index: -10;
      pointer-events: auto;
    }
  }

  .buttons-list{
    padding: 0px 30px 0px;

    .btn + .btn{
      margin-left: 25px;
    }
    
    .show-button{
      .schevron{
        transition: all cubic-bezier(0.175, 0.885, 0.32, 1.275) .3s;
        margin-left: 15px;
      }

      &.active{
        .schevron{
          transform: rotate(180deg);
        }
      }
    }

  }
}
</style>
